<script setup>
import { ref, computed, onUnmounted } from 'vue'
const router = useRouter()
const phoneNumber = ref('')
const verificationCode = ref('')
const password = ref('')
const isPasswordLogin = ref(false)
const isAgreed = ref(false)
const isCountingDown = ref(false)
const countdown = ref(60)
let timer = null

// 聚焦状态变量
const phoneFocused = ref(false)
const codeFocused = ref(false)
const passwordFocused = ref(false)

const isPhoneNumberValid = computed(() => {
    return /^1[3-9]\d{9}$/.test(phoneNumber.value)
})

const canLogin = computed(() => {
    if (!isPhoneNumberValid.value) return false
    if (isPasswordLogin.value) {
        return password.value.length >= 6
    } else {
        return verificationCode.value.length === 6
    }
})

async function sendVerificationCode() {
    if (isCountingDown.value || !isPhoneNumberValid.value) return
    if (!isPhoneNumberValid.value) {
        showToast({ message: "请输入有效的手机号" });
        return
    }
    const { data, error } = await useApiFetch('auth/sendSms')
        .post({ mobile: phoneNumber.value, actionType: 'login' })
        .json()

    if (data.value && !error.value) {
        if (data.value.code === 200) {
            showToast({ message: "获取成功" });
            startCountdown()
        } else {
            showToast(data.value.msg)
        }
    }
}

function startCountdown() {
    isCountingDown.value = true
    countdown.value = 60
    timer = setInterval(() => {
        if (countdown.value > 0) {
            countdown.value--
        } else {
            clearInterval(timer)
            isCountingDown.value = false
        }
    }, 1000)
}

async function handleLogin() {
    if (!isPhoneNumberValid.value) {
        showToast({ message: "请输入有效的手机号" });
        return
    }
    if (isPasswordLogin.value) {
        if (password.value.length < 6) {
            showToast({ message: "密码长度不能小于6位" });
            return
        }
    } else {
        if (verificationCode.value.length !== 6) {
            showToast({ message: "请输入有效的验证码" });
        }
    }
    if (!isAgreed.value) {
        showToast({ message: "请先同意用户协议" });
        return
    }

    const { data, error } = await useApiFetch('/user/mobileCodeLogin')
        .post({ mobile: phoneNumber.value, code: verificationCode.value })
        .json()

    if (data.value && !error.value) {
        if (data.value.code === 200) {
            localStorage.setItem('token', data.value.data.accessToken)
            localStorage.setItem('refreshAfter', data.value.data.refreshAfter)
            // if (phoneNumber.value === "18276151590") {
            //     localStorage.setItem('m', "shifenliangzai")
            // }
            window.location.href = '/'
        }
    }
}

function toUserAgreement() {
    router.push(`/userAgreement`)
}

function toPrivacyPolicy() {
    router.push(`/privacyPolicy`)
}

onUnmounted(() => {
    if (timer) {
        clearInterval(timer)
    }
})
const onClickLeft = () => {
    router.replace('/')
}
</script>

<template>
    <div class="login-layout ">
        <van-nav-bar fixed placeholder title="用户登录" left-text="" left-arrow @click-left="onClickLeft" />
        <div class="login px-8">
            <div class="mb-8 pt-8 text-left">
                <div class="flex flex-col items-center">
                    <img class="h-16 w-16 rounded-full shadow" src="@/assets/images/logo.png" alt="Logo" />
                    <div class="text-3xl mt-4 text-slate-700 font-bold">全能查</div>
                </div>
            </div>

            <div class="space-y-5">
                <!-- 手机号输入 -->
                <div :class="['input-container bg-blue-300/20', phoneFocused ? 'focused' : '']">
                    <input v-model="phoneNumber" class="input-field" type="tel" placeholder="请输入手机号" maxlength="11"
                        @focus="phoneFocused = true" @blur="phoneFocused = false" />
                </div>

                <!-- 验证码输入 -->
                <div v-if="!isPasswordLogin">
                    <div class="flex items-center justify-between">
                        <div :class="['input-container bg-blue-300/20', codeFocused ? 'focused' : '']">
                            <input v-model="verificationCode" class="input-field" placeholder="请输入验证码" maxlength="6"
                                @focus="codeFocused = true" @blur="codeFocused = false" />
                        </div>
                        <button
                            class="ml-2 px-4 py-2 text-sm font-bold flex-shrink-0 rounded-lg transition duration-300"
                            :class="isCountingDown || !isPhoneNumberValid ? 'cursor-not-allowed bg-gray-300 text-gray-500' : 'bg-blue-500 text-white hover:bg-blue-600'"
                            @click="sendVerificationCode">
                            {{ isCountingDown ? `${countdown}s重新获取` : '获取验证码' }}
                        </button>
                    </div>
                </div>

                <!-- 密码输入 -->
                <div v-if="isPasswordLogin" :class="['input-container', passwordFocused ? 'focused' : '']">
                    <input v-model="password" class="input-field" type="password" placeholder="请输入密码"
                        @focus="passwordFocused = true" @blur="passwordFocused = false" />
                </div>

                <!-- 协议同意框 -->
                <div class="flex items-start space-x-2">
                    <input type="checkbox" v-model="isAgreed" class="mt-1" />
                    <span class="text-xs text-gray-400 leading-tight">
                        未注册手机号登录后将自动生成账号，并且代表您已阅读并同意
                        <a class="cursor-pointer text-blue-400" @click="toUserAgreement">
                            《用户协议》
                        </a>
                        和
                        <a class="cursor-pointer text-blue-400" @click="toPrivacyPolicy">
                            《隐私政策》
                        </a>
                    </span>
                </div>
            </div>

            <button
                class="mt-20 w-full py-3 text-lg font-bold text-white bg-blue-500 rounded-full transition duration-300"
                @click="handleLogin">
                登录
            </button>
        </div>
    </div>
</template>

<style scoped>
.login-layout {
    background: url("@/assets/images/login_bg.png") no-repeat;
    background-position: center;
    background-size: cover;
    height: 100vh;
}

.input-container {
    border: 2px solid rgba(125, 211, 252, 0.0);
    border-radius: 1rem;
    transition: duration-200;
}

.input-container.focused {
    border: 2px solid #3b82f6;
}

.input-field {
    width: 100%;
    padding: 1rem;
    background: transparent;
    border: none;
    outline: none;
    transition: border-color 0.3s ease;
}
</style>
